/* Machine-dependent pthreads configuration and inline functions.

   Copyright (C) 1996, 1997, 1998, 2000 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   Contributed by Ralf Baechle <ralf@gnu.org>.
   Based on the Alpha version by Richard Henderson <rth@tamu.edu>.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2 of the
   License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with the GNU C Library; see the file COPYING.LIB.  If
   not, write to the Free Software Foundation, Inc.,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */

#ifndef PT_EI
# define PT_EI extern inline
#endif

#include <eti/mm.h>

#define MEMORY_BARRIER() \
  do { hmpv_endtrace(); } while(0)

extern unsigned long __eti_atomic_test_and_set(int *); /* sysdeps/bsp/atomic_tas.S */

PT_EI long int testandset (int *spinlock)
{
    return __eti_atomic_test_and_set(spinlock); 
}

#undef HAS_COMPARE_AND_SWAP
#undef HAS_COMPARE_AND_SWAP_WITH_RELEASE_SEMANTICS
#undef TEST_FOR_COMPARE_AND_SWAP

/* Get some notion of the current stack.  Need not be exactly the top
   of the stack, just something somewhere in the current frame.  */
#define CURRENT_STACK_FRAME  __builtin_frame_address(0)
