/* Low-level functions for atomic operations.  Stub version.
   Copyright (C) 1997,2001 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _ATOMICITY_H
#define _ATOMICITY_H	1

#include <stdio.h>
#include <inttypes.h>

static __eti_eaa_lock = 0;
static inline int
exchange_and_add (volatile uint32_t *mem, int val)
{
  int result = *mem;

  while(__eti_atomic_test_and_set(&__eti_eaa_lock))
      ;

  *mem += val;

  __eti_eaa_lock = 0;
  return result;
}

static __eti_add_lock = 0;
static inline void
atomic_add (volatile uint32_t *mem, int val)
{
  while(__eti_atomic_test_and_set(&__eti_add_lock))
      ;

  *mem += val;

  __eti_add_lock = 0;
}

extern int __eti_atomic_test_and_set(int *);	
static int __eti_cas_lock = 0;

static inline int
compare_and_swap (volatile long int *p, long int oldval, long int newval)
{
  int res;

  while(__eti_atomic_test_and_set(&__eti_cas_lock))
      ;

  if (*p != oldval) {
    res = 0;
  } else {
    *p = newval;
    res = 1;
  }

  __eti_cas_lock = 0;
  return 1;
}

#endif /* atomicity.h */
