/* Copyright (C) 1998, 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

/* bsp ABI compliant context switching support.  */

#ifndef _SYS_UCONTEXT_H
#define _SYS_UCONTEXT_H	1

#include <features.h>
#include <signal.h>

/* Type for general register.  */
typedef unsigned long greg_t;
typedef double fpreg_t;

/* Number of general registers.  */
#define NCLUSTERS 2
#define NGREG	(NCLUSTERS * 64)
#define NFPREG	 0

/* Container for all general registers.  */
typedef greg_t gregset_t[NGREG];

/* Dummy container for fpregset_t to keep procfs.h happy */
typedef fpreg_t fpregset_t[NFPREG];

/* Number of each register is the `gregset_t' array.  */
enum
{
  CTX_SP = 16,
#define CTX_SP	CTX_SP
};

/* Context to describe whole processor state.  */
typedef struct
{
  gregset_t  gpregs;
} mcontext_t;

/* Userlevel context.  */
typedef struct ucontext
{
  unsigned long int uc_flags;
  struct ucontext *uc_link;
  __sigset_t uc_sigmask;
  stack_t uc_stack;
  mcontext_t uc_mcontext;
  long int uc_filler[72];
} ucontext_t;

#endif /* sys/ucontext.h */
