#include <errno.h>
#include <sched.h>
#include <stdio.h>

extern int _sys_clone( int, void* );

int __clone( int (*fn) (void* arg), void* child_stack, int flags, void* arg )
{
   int retval;

   if ( fn == NULL || child_stack == NULL )
   {
      __set_errno(EINVAL);
      return -1;
   }

   retval = _sys_clone(flags, child_stack);

   if ( retval == 0 )
      _exit( fn(arg) );

   return retval;
}
